/*
 * Zed Attack Proxy (ZAP) and its related class files.
 *
 * ZAP is an HTTP/HTTPS proxy for assessing web application security.
 *
 * Copyright 2010 The ZAP Development Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.zaproxy.zap.view;

import org.parosproxy.paros.view.AbstractFrame;

public class AboutWindow extends AbstractFrame {

    private static final long serialVersionUID = 1L;
    private AboutPanel aboutPanel = null;

    public AboutWindow() {
        super();
        initialize();
    }

    /** This method initializes this */
    private void initialize() {
        this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
        this.setResizable(false);
        this.setContentPane(getAboutPanel());
        this.pack();
        centerFrame();
    }

    /**
     * This method initializes aboutPanel
     *
     * @return org.parosproxy.paros.view.AboutPanel
     */
    private AboutPanel getAboutPanel() {
        if (aboutPanel == null) {
            aboutPanel = new AboutPanel();
        }
        return aboutPanel;
    }
}
